
VIDRAM	 	EQU		$0400			; video RAM

INTCNV		EQU		$B3ED			; get parameter from BASIC
GIVABF		EQU		$B4F4			; passes parameter to BASIC

			ORG		$3000

**
*  Prints a reversed ASCII string
*    D=VARPTR of the string to print
**
START		JSR		INTCNV			; get value passed by BASIC in D
			TFR		D,X				; move value (varptr) to X

			LDA		1,X				; load row
			LDB		#32				; 32 characters/row
			MUL						; multiply
			ADDB	4,X				; add column
			ADCA	#0				; add carry
			LDY		#VIDRAM			; load video ram address
			LEAY	D,Y

			LDB		,X				; load string length
			BEQ		DONE			; exit if null
			LDX		2,X				; load string address

LOOP		LDA		,X+				; load character
			JSR		TORASC			; convert to reverse ASCII
			STA		,Y+				; print on screen
			DECB					; decrement character counter
			BNE		LOOP			; repeat until done

DONE		JMP		GIVABF			; return to BASIC

**
*  TORASC
*   A = CHAR
**
TORASC		BEQ		TORASC03
			CMPA	#64
			BLT		TORASC03

TORASC01	CMPA	#96
			BLT		TORASC02
			SUBA	#96
			BRA		TORASC03
TORASC02	SUBA	#64

TORASC03	RTS

			END